<?php

namespace ACL\Controllers;

use ACL\Traits\TResponse;
use Exception;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use ACL\Helpers\Instances\InstanceProvider;
use ACL\Util\AclUtilities;
use ACL\Services\Cliente as ClienteService;

class Cliente {

    use TResponse;

    /**
     * @var ClienteService
     */
    private $clienteService;

    public function __construct(ClienteService $clienteService)
    {
        $this->clienteService = $clienteService;
    }

    public function findAllCliente(Request $request, Response $response)
    {
        try {
            $data = $this->clienteService->findAllCliente();
            $this->sendResponse($data, 200);
        } catch (Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }
}
