<?php

namespace ACL\Crud;

use ACL\Traits\TResponse;
use Exception;
use Zeedhi\Framework\DTO\Request;

class CrudController
{
    use TResponse;
    /**
     * @var CrudService
     */
    private $crudService;

    /**
     * CrudController constructor.
     * @param CrudService $crudService
     */
    public function __construct(CrudService $crudService)
    {
        $this->crudService = $crudService;
    }

    /**
     * @param Request $request
     * @throws Exception
     */
    public function find(Request $request)
    {
        try {
            $params = $request->getParameters();
            $table = $request->getParameter('table');
            $columns = isset($params['columns']) ? $params['columns'] : null;

            $data = $this->crudService->find($table, $columns);
            $this->sendResponse($data, 200);
        } catch (Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }
}