import { Loader, Singleton } from '@zeedhi/core';
import { OperadorController } from '@/controllers/Operador/OperadorController';
import { OperadorService } from '@/services/OperadorService';

@Singleton
export class OperadorDetailController {
	public operadorControler: OperadorController;

	public operadorService: OperadorService;

	public get isVisibleOperadorDetail() {
		return !this.operadorControler.isVisibleGridAndDetail;
	}

	public get currentOperadorName(): string {
		return this.operadorControler.currentOperador.NMOPERADOR || '';
	}

	public get visibleOnlyInCompleteMode(): boolean {
		return this.operadorControler.showFullOperatorWindow;
	}

	constructor() {
		this.operadorControler = Loader.getInstance('OperadorController');
		this.operadorService = new OperadorService();
	}

	public async clickBackToOperadorGrid() {
		this.operadorControler.isVisibleGridAndDetail = true;
		if (this.operadorControler.isReloadOperadorGrid) {
			await this.operadorControler.getInstanceOperadorGrid().reload();
		}
		this.operadorControler.isReloadOperadorGrid = false;
	}

	public async changeOperadorDetailTabs() {
		this.operadorControler.changeOperadorDetailTabs();
	}
}
